import java.awt.*;
import java.awt.event.*;
import java.util.*;
import de.kawt.*;

/**
 * This is the middle project of the OOP
 *
 * Creation date: (2002/05/13 13:05:29)
 * @version 1.0
 * @author 8824015 {[
 */
public class LottoRandom extends KAWTlet implements ActionListener {

    private Label[] label = new Label[6];
    private Checkbox[] checkbox = new Checkbox[42];
    private Button startButton;
    private Panel northPanel, westPanel, centerPanel, startPanel, labelPanel, eastPanel, southPanel;
    
    Frame frame = new Frame ();

    public LottoRandom () {
        
        MenuBar menuBar = new MenuBar ();
        Menu menu = new Menu ("Info");
        MenuItem mi = new MenuItem ("About Lotto");
        mi.addActionListener (this);
        menu.add (mi);

        mi = new MenuItem ("Memory");
        mi.addActionListener (this);
        menu.add (mi);

        mi = new MenuItem ("Exit");
        mi.addActionListener (this);
        menu.add (mi);
	
	    menuBar.add (menu);

        frame.setMenuBar (menuBar);
        
        centerPanel = new Panel(new GridLayout(2,1));
        
        startPanel = new Panel();
        startButton = new Button("Start");
        startButton.addActionListener(this);
        startPanel.add(startButton);
        centerPanel.add(startPanel);
        
        labelPanel = new Panel(new GridLayout(1,6));
        for (int i = 0 ; i < label.length; i++) {
            label[i] = new Label();
            label[i].setForeground(Color.red);
            labelPanel.add(label[i]);
        }
        centerPanel.add(labelPanel);
        
        northPanel = new Panel(new GridLayout(1,9));
        for (int i = 0; i <= 8; i++) {
           addCheckBox(i, checkbox, northPanel);
        }
        
        eastPanel = new Panel(new GridLayout(13,1));
        for (int i = 9; i <= 21; i++) {
           addCheckBox(i, checkbox, eastPanel);
        }
        
        southPanel = new Panel(new GridLayout(1,7));
        for (int i = 28; i >= 22; i--) {
           addCheckBox(i, checkbox, southPanel);
        }
        
        westPanel = new Panel(new GridLayout(13,1));
        for (int i = 41; i >= 29; i--) {
           addCheckBox(i, checkbox, westPanel);
        }
        
        frame.add("North", northPanel);
        frame.add("East", eastPanel);
        frame.add("South", southPanel);
        frame.add("West", westPanel);
        frame.add("Center", centerPanel);
        
	frame.addWindowListener (new Closer (this));

        frame.pack ();
    } /* end of method LottoRandom() */
    
    private void addCheckBox(int index, Checkbox[] checkbox, Container container) {
        checkbox[index] = new Checkbox((index + 1) + "");
        container.add(checkbox[index]);
    } /* end of method addCheckBox() */
    
    public void startApp () {
	   frame.show ();
    } /* end of method startApp() */

    public void destroyApp (boolean uncond) {
	   frame.dispose ();
    } /* end of method destroyApp() */
    
    public void actionPerformed (ActionEvent e) {
	String cmd = e.getActionCommand ();
	if (cmd.equals ("About kAWT")) {
	    OptionDialog.showMessageDialog 
		(frame, "For information about Lotto, please visit\nhttp://www.Lotto.com");
	} else if (cmd.equals ("Memory")) {
	    int count = 0;
	    long free0 = Runtime.getRuntime().freeMemory ();
	    long free = free0;
	    while (true) {
		Runtime.getRuntime().gc();
		long newFree = Runtime.getRuntime().freeMemory ();
		if (newFree <= free) break;
		count ++;
		free = newFree;
	    }
	    OptionDialog.showMessageDialog (frame, "ini: "+free0+"\ngc"+count+": "+free);
	} else  if (cmd.equals ("Exit")) {
            destroyApp (true);
            new Lotto ().startApp ();
            notifyDestroyed ();
	} else if (cmd.equals ("Start")) {
            for (int i = 0 ; i < label.length; i++) {
               label[i].setText("");
            }
            Bala bala = new Bala();
            Thread balaThread = new Thread(bala);
            balaThread.start();
	}
    } /* end of method actionPerformed() */

    public static void main (String [] argv) {
        new LottoRandom ().startApp ();
    }
    
    class Bala implements Runnable {
       private static final long ONE_SECOND = 1000L;
       
       private int[] generateRandom() {
         Vector v = new Vector(42);
         Random r = new Random();
         int index = 0;
         int[] result = new int []{0,0,0,0,0,0};
    
         for (int i = 1; i <= 42; i++) {
              v.addElement(i+"");
         }
    
         for (int i = 0; i < result.length; i++) {
            index = Math.abs(r.nextInt()) % (42 - i);
            result[i] = Integer.parseInt((String)v.elementAt(index));
            v.removeElementAt(index);
         }
        
         return result;
       } /* end of method generateRandom() */
       
       public void run() {
             try {
                 for (int j = 0; j < 3; j++) {
                   Thread.sleep(ONE_SECOND);
                   for (int i = 0; i < checkbox.length; i++) {
                      checkbox[i].setState(true);
                   }
                   Thread.sleep(ONE_SECOND);
                   for (int i = 0; i < checkbox.length; i++) {
                      checkbox[i].setState(false);
                   }
                 }
             } catch (InterruptedException e) {}
             int[] result = generateRandom();
             for (int i = 0 ; i < label.length; i++) {
               checkbox[result[i] - 1 ].setState(true);
               label[i].setText(result[i]+"");
             }
       } /* end of method run() */
    } /* end of class Bala */
} /* end of class LottoRandom */ 