import java.awt.*;
import java.awt.event.*;
import java.util.*;
import de.kawt.*;


public class LottoRecommand extends KAWTlet implements ActionListener {

    private Frame frame = new Frame ();
    Label label, result;
    
    public LottoRecommand () {
        MenuBar menuBar = new MenuBar ();
        Menu menu = new Menu ("Info");
        MenuItem mi = new MenuItem ("About Lotto");
        mi.addActionListener (this);
        menu.add (mi);

        mi = new MenuItem ("Memory");
        mi.addActionListener (this);
        menu.add (mi);
	
	    mi = new MenuItem ("Exit");
        mi.addActionListener (this);
        menu.add (mi);
	   
	    menuBar.add (menu);
	    
        frame.setMenuBar (menuBar);
        
        Panel containPanel = new Panel(new FlowLayout());
        
        label = new Label("We recommand numbers as follows");
        containPanel.add(label);
        
        int array[] = getRndNumber(6);
        
        result = new Label(array[0] + "  " + array[1] + "  " + array[2] + "  " + array[3] + "  " + array[4] + "  " + array[5]);
        result.setForeground(Color.red);
        containPanel.add(result);
        
        frame.add(containPanel);
	    frame.addWindowListener (new Closer (this));

        frame.pack ();
    }
    
    public void startApp () {
	    frame.show ();
    }


    public void destroyApp (boolean uncond) {
	    frame.dispose ();
    }
    
    
    public void actionPerformed (ActionEvent e) {
	  String cmd = e.getActionCommand ();
	  if (cmd.equals ("About Lotto")) {
	      OptionDialog.showMessageDialog 
		  (frame, "For information about Lotto, please visit\nhttp://www.Lotto.com");
	  } else if (cmd.equals ("Memory")) {
   	      int count = 0;
	      long free0 = Runtime.getRuntime().freeMemory ();
	      long free = free0;
	      while (true) {
		    Runtime.getRuntime().gc();
		    long newFree = Runtime.getRuntime().freeMemory ();
		    if (newFree <= free) break;
		    count ++;
		    free = newFree;
	      }
	      OptionDialog.showMessageDialog (frame, "ini: "+free0+"\ngc"+count+": "+free);
	  } else  if (cmd.equals ("Exit")) {
            destroyApp (true);
            new Lotto ().startApp ();
            notifyDestroyed ();
      }	  
    }

    public static void main (String [] argv) {
        new LottoRecommand ().startApp ();
    }

    public static int[] getRndNumber(int arrayLength)
    {
        int weight[] = {2, 3, 1, 3, 3, 3, 4, 1, 3, 3,
                        1, 3, 2, 2, 4, 2, 2, 1, 1, 4,
                        3, 1, 2, 1, 3, 3, 3, 2, 4, 3,
                        2, 3, 2, 3, 2, 4, 3, 1, 4, 1,
                        1, 1 };
        int array[] = new int[arrayLength];
        for (int i=0; i<array.length; i++)
        {
            int tmp = -1;
            array[i] = -1;
            Random r = new Random();
            while (isExist(array, tmp))
                tmp = Math.abs(r.nextInt() %100) ;
            array[i] = tmp;
        }

        for (int i=0; i<array.length; i++)
        {
            int sum = 0;
            for (int j=0; j<weight.length; j++)
            {
                sum += weight[j];
                if (sum >= array[i])
                {
                    array[i] = j + 1;
                    break;
                }
            }
        }

        return array;
    }
    
    public static boolean isExist(int[] array, int testNumber)
    {
        for (int i=0; i<array.length; i++)
            if (array[i] == testNumber)
                return true;
        return false;
    }
    
}